import { j as n } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as we, useState as Q, useMemo as p, useRef as F, useEffect as Ne, useCallback as Ce } from "react";
import { isMobile as T } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as ve, Table as H } from "antd";
import Te from "../../BitzDrawer/index.mjs";
import ke from "../../BitzPagination/index.mjs";
import Be from "../../BitzNoData/index.mjs";
import Ae, { TableContext as ze } from "../Store/index.mjs";
import Me from "../TableSkeleton/index.mjs";
import { columnSort as Y, genColumnKey as Z } from "../Store/utils/index.mjs";
import P from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import "../../BitzList/index.less.mjs";
import S from "../../BitzList/List.mjs";
import "../../BitzPullRefresh/style/index.less.mjs";
import De from "../../BitzPullRefresh/PullRefresh.mjs";
import I from "../../../node_modules/lodash-es/at.mjs";
function Le({ showPagination: w = !0, fillEvenRow: E = !0, evenRowBgColor: W = "#f9f9f9", height: N, dataSource: o = [], total: k = 0, columns: b, loading: B = !1, skeletonNum: Fe = 2, skeletonRender: He, skeletonRowNum: Pe = 4, skeletonRowsWidth: Ee = ["35%", "100%", "100%", "60%"], mobileLoadEmit: m, mobileRefreshEmit: R, operationFilter: A, enableControlPage: ee, pagination: ne, paginationEmit: le = () => {
}, mobilePageHeight: We = 500, mobileCancelText: se = "取消", noDataTitle: oe, noDataImg: re, color: me, size: $, showTableTool: ie = !0, tableAction: te, tableToolbar: ae, selectionBar: de, scroll: a, resetPage: he, ...d }) {
  const { token: xe } = ve.useToken(), h = we(ze), [ue, z] = Q(!1), O = p(() => !!(o != null && o.length) && (o == null ? void 0 : o.length) >= k, [o, k]), [fe, ce] = Q([]), V = (l, s) => {
    var t;
    const e = (t = A == null ? void 0 : A(l, s)) == null ? void 0 : t.filter((i) => i.type !== "divider");
    e != null && e.length && (ce(e), z(!0));
  }, K = () => {
    z(!1);
  }, be = (l) => {
    var s;
    z(!1), (s = l.onClick) == null || s.call(l);
  }, g = F(null), j = P(g), M = F(null), D = P(M), _ = F(null), y = P(_), ge = (l) => {
    var G, J;
    const s = l.length, e = l.filter((c) => c.width), i = e.map((c) => c.width).reduce((c, pe) => c + pe, 0);
    let x = 0;
    if (g.current) {
      const c = window.getComputedStyle(g.current);
      x = parseInt(c.getPropertyValue("--toolCell-width"));
    }
    let r = 0;
    d.rowSelection && (r += x), d.expandable && (r += x);
    const f = (J = (G = M.current) == null ? void 0 : G.querySelector(".ant-table-body")) == null ? void 0 : J.clientWidth, v = parseInt(`${C.x}`) || 0, ye = Math.max(v, f), q = (parseInt(`${ye}`) || 0) - i - r;
    return q >= 0 ? q / (s - e.length) : void 0;
  }, { y: L } = p(() => {
    if (typeof N > "u")
      return {};
    let l = 40, s = 40, e = 10;
    if (g.current) {
      const f = window.getComputedStyle(g.current);
      l = parseInt(f.getPropertyValue("--cell-block")), s = parseInt(f.getPropertyValue("--toolbar-height")), e = parseInt(f.getPropertyValue("--container-gap")) || 0;
    }
    const t = (y == null ? void 0 : y.height) || 0, i = t ? e : 0;
    return { y: N - t - i - s - l };
  }, [
    N,
    y == null ? void 0 : y.height,
    j == null ? void 0 : j.height,
    D == null ? void 0 : D.height
  ]), C = p(() => a != null && a.x ? { x: a.x, y: a.y || L } : a != null && a.y ? { x: 1e3, y: a.y } : { x: 1e3, y: L }, [a, L]), u = p(() => {
    const l = (x) => x.map((r) => {
      const f = Z((r == null ? void 0 : r.key) || (r == null ? void 0 : r.dataIndex), r.index), v = h.columnsMap[f];
      return v && v.show === !1 ? !1 : r.children ? {
        ...r,
        children: l(r.children)
      } : r;
    }).filter(Boolean), s = l(b);
    if (T)
      return s.sort(Y(h.columnsMap));
    const e = s.sort(Y(h.columnsMap)), t = ge(e), i = e.map((x) => ({
      ...x,
      ...x.width ? {} : {
        // 给未设置width的列设置平均数
        width: t
      }
    }));
    return [H.SELECTION_COLUMN, H.EXPAND_COLUMN, ...i];
  }, [
    h.columnsMap,
    b,
    T,
    C.x,
    d.rowSelection,
    d.expandable,
    j == null ? void 0 : j.height
  ]);
  Ne(() => {
    if (b && b.length > 0) {
      const l = b.map((s) => (
        // @ts-ignore
        Z((s == null ? void 0 : s.key) ?? (s == null ? void 0 : s.dataIndex), s == null ? void 0 : s.dataIndex)
      ));
      h.setSortKeyColumns(l);
    }
  }, [b]);
  const je = p(() => `${$ ?? (h == null ? void 0 : h.tableSize) ?? "lg"}BitzTable`, [$, h.tableSize]), U = p(() => ({
    "--evenRow-BgColor": W
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    W
    /** token.Table?.borderColor */
  ]), X = Ce((l, s) => E ? s % 2 === 0 ? "oddRow" : "evenRow" : "", [E]);
  return n.jsxs("div", { className: "bitzTableBlock", children: [!T && n.jsxs("div", { ref: g, className: `bitzTableContainer ${je}`, style: { height: N }, children: [n.jsxs("div", { className: "bitzTableContainerBody", ref: M, children: [ie && n.jsxs("div", { className: "bitzTableToolbarBlock", children: [te || n.jsx("div", {}), ae, (d == null ? void 0 : d.rowSelection) && n.jsx(n.Fragment, { children: de })] }), n.jsx(H, { columns: u, dataSource: o, loading: !1, pagination: !1, scroll: C, ...d, style: U, rowClassName: X }), n.jsx(Me, { columns: u, dataLength: o.length, scroll: C, rowSelection: d.rowSelection, expandable: d.expandable, style: U, rowClassName: X, loading: B })] }), w && n.jsx(ke, { elRefInstance: _, enableControl: ee, pagination: ne, total: k, dataSource: o, resetPage: he, paginationEmit: le })] }), T && n.jsxs(n.Fragment, { children: [(B || (o == null ? void 0 : o.length) > 0) && // @ts-ignore
  n.jsx(n.Fragment, { children: R ? n.jsx(De, { onRefresh: R, children: n.jsx(S, {
    finished: O,
    // @ts-ignore
    onLoad: m,
    loadingText: "加载中...",
    finishedText: "没有更多了",
    errorText: "加载失败",
    children: n.jsx("div", { className: "mobileTable", children: o == null ? void 0 : o.map((l, s) => n.jsx("div", { className: "mobileTableRow", onClick: () => V(l, s), children: n.jsx("div", { className: "rowBox", children: u == null ? void 0 : u.map((e, t) => {
      var i;
      return n.jsx("div", { children: !(e != null && e.mobileHide) && n.jsxs("div", { className: "row", children: [!e.mobileHideLabel && n.jsxs("div", { className: "label", children: [`${e.title}`, "："] }), n.jsx("div", { className: "value", children: ((i = e == null ? void 0 : e.render) == null ? void 0 : i.call(e, I(l, (e == null ? void 0 : e.dataIndex) || ""), l, s)) || (l == null ? void 0 : l[e.dataIndex]) })] }) }, t);
    }) }) }, s)) })
  }) }) : n.jsx(S, {
    finished: O,
    // @ts-ignore
    onLoad: m,
    loadingText: "加载中...",
    finishedText: "没有更多了",
    errorText: "加载失败",
    children: n.jsx("div", { className: "mobileTable", children: o == null ? void 0 : o.map((l, s) => n.jsx("div", { className: "mobileTableRow", onClick: () => V(l, s), children: n.jsx("div", { className: "rowBox", children: u == null ? void 0 : u.map((e, t) => {
      var i;
      return n.jsx("div", { children: !(e != null && e.mobileHide) && n.jsxs("div", { className: "row", children: [!e.mobileHideLabel && n.jsxs("div", { className: "label", children: [`${e.title}`, "："] }), n.jsx("div", { className: "value", children: ((i = e == null ? void 0 : e.render) == null ? void 0 : i.call(e, I(l, (e == null ? void 0 : e.dataIndex) || ""), l, s)) || (l == null ? void 0 : l[e.dataIndex]) })] }) }, t);
    }) }) }, s)) })
  }) }), !B && n.jsx(Be, { data: o, title: oe, img: re }), n.jsx(Te, { className: "tableMobileDrawer", open: ue, placement: "bottom", height: "auto", closable: !1, onClose: K, children: n.jsxs("div", { className: "drawerBox", children: [n.jsx("div", { className: "boxBody", children: fe.map((l, s) => n.jsx("div", { className: "operaList", onClick: () => be(l), ...l.danger && {
    style: { color: xe.colorError }
  }, children: l.label }, s)) }), n.jsx("div", { className: "boxLine" }), n.jsx("div", { className: "boxFooter", onClick: K, children: se })] }) })] })] });
}
const nn = (w) => (
  // @ts-ignore
  n.jsx(Ae, { initValue: w, children: n.jsx(Le, { ...w }) })
);
export {
  nn as default
};
