import { j as e } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as X, useModal as Y, antdModalV5 as Z } from "@ebay/nice-modal-react";
import { Modal as _, Checkbox as $ } from "antd";
import t from "./index.module.less.mjs";
import { useState as w, useContext as L, useEffect as ss, useCallback as B, useMemo as y } from "react";
import { TableContext as es } from "../../Store/index.mjs";
import { genColumnKey as g, columnSort as os } from "../../Store/utils/index.mjs";
import F from "../../../../node_modules/classnames/index.mjs";
import { DndContext as ls, DragOverlay as ts, defaultDropAnimationSideEffects as ns } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as as, verticalListSortingStrategy as cs, arrayMove as is } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import rs from "./DndItem.mjs";
import { restrictToVerticalAxis as ms, restrictToWindowEdges as us } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import T from "../../../BitzButton/index.mjs";
import "./index.less.mjs";
import { useImmer as ds } from "../../../../node_modules/use-immer/dist/use-immer.module.mjs";
import ps from "../../../../assets/iconfont/IconTuodong.mjs";
import O from "../../../../node_modules/lodash-es/omit.mjs";
import xs from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import hs from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
const fs = {
  sideEffects: ns({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, Os = X(() => {
  var S;
  const x = Y(), [d, j] = w(null), [z, v] = w(!1), [c, h] = ds({
    columnsMap: {},
    sortKeyColumns: []
  }), {
    persistenceType: R,
    persistenceKey: k,
    onlineChange: C,
    columnsMap: V,
    setColumnsMap: W,
    sortKeyColumns: q,
    setSortKeyColumns: G,
    // clearPersistenceStorage,
    ...l
  } = L(es);
  ss(() => {
    h((s) => {
      s.columnsMap = { ...V }, s.sortKeyColumns = [...q];
    });
  }, []);
  const H = B(() => {
    h((s) => {
      s.columnsMap = { ...l.defaultColumnKeyMap };
    });
  }, []), p = y(() => {
    var o, n;
    const s = [];
    return (o = l == null ? void 0 : l.columns) != null && o.length && ((n = l == null ? void 0 : l.columns) == null || n.map(({ key: u, dataIndex: a, ...r }) => {
      const f = g(u || a, [u || a].filter(Boolean).join("-")), m = c.columnsMap[f || "null"];
      return (m == null ? void 0 : m.show) !== !1 && s.push({
        key: f,
        ...O(r, ["className"]),
        selectable: !1,
        disabled: (m == null ? void 0 : m.disable) === !0
      }), m;
    })), s.sort(os(c.columnsMap));
  }, [c.columnsMap, l == null ? void 0 : l.columns]), M = B((s) => {
    var o;
    return (o = c.sortKeyColumns) == null ? void 0 : o.findIndex((n) => n === s);
  }, [c.sortKeyColumns]), N = y(() => d ? M(d) : -1, [d, M]), E = y(() => {
    const s = [], o = /* @__PURE__ */ new Map();
    return { list: ((u, a) => u.map(({ key: r, dataIndex: f, children: m, ...K }) => {
      var I;
      const b = g(r || f, [a == null ? void 0 : a.columnKey, K.index].filter(Boolean).join("-")), i = c.columnsMap[b || "null"] || { show: !0 };
      (i == null ? void 0 : i.show) !== !1 && !m && s.push(b);
      const A = {
        key: b,
        ...O(K, ["className"]),
        selectable: !1,
        disabled: i.disable === !0,
        disableCheckbox: typeof i.disable == "boolean" ? i == null ? void 0 : i.disable : (I = i == null ? void 0 : i.disable) == null ? void 0 : I.checkbox,
        isLeaf: a ? !0 : void 0
      };
      return o.set(r, A), A;
    }))(l == null ? void 0 : l.columns), keys: s, map: o };
  }, [c.columnsMap, l == null ? void 0 : l.columns]), J = (s, o) => {
    const n = { ...c.columnsMap };
    ((a) => {
      const r = { ...n[a] };
      r.show = !s, n[a] = r;
    })(o.key), v(!0), h((a) => {
      a.columnsMap = { ...n };
    });
  }, P = (s, o) => {
    const n = { ...c.columnsMap }, u = is(c.sortKeyColumns, s, o);
    u.forEach((a, r) => {
      n[a] = { ...n[a] || {}, order: r };
    }), v(!0), h((a) => {
      a.columnsMap = { ...n }, a.sortKeyColumns = u;
    });
  }, Q = y(() => {
    var s, o;
    return d ? ((o = (s = l == null ? void 0 : l.columns) == null ? void 0 : s.find((n) => n.key === d)) == null ? void 0 : o.title) ?? "" : "";
  }, [l == null ? void 0 : l.columns, d]), U = () => {
    W(c.columnsMap), G(c.sortKeyColumns), R === "online" && k && (C == null || C(k, c.columnsMap)), x.resolve({ ...c.columnsMap }), x.hide();
  }, D = () => {
    x.hide();
  };
  return e.jsxs(_, { className: "tableColumnSettingModal", title: "自定义列", ...Z(x), width: 600, onCancel: D, footer: e.jsxs(e.Fragment, { children: [e.jsx(T, { type: "primary", icon: e.jsx(xs, {}), onClick: U, disabled: !z, children: "保存" }), e.jsx(T, { onClick: D, children: "取消" })] }), children: [e.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }), e.jsxs("div", { className: t.container, children: [e.jsxs("div", { className: t.block, children: [e.jsxs("div", { className: t.header, children: [e.jsx("div", { className: t.title, children: "可用列" }), e.jsx("div", {})] }), e.jsx("div", { className: t.body, children: e.jsx("ul", { className: t.content, children: (S = E.list) == null ? void 0 : S.map((s) => {
    const o = E.keys.includes(s.key);
    return e.jsxs("li", { className: F(t.item, {
      [t.checked]: !o
    }), onClick: () => !s.disabled && J(o, s), children: [e.jsx($, { checked: o, disabled: s.disabled }), e.jsx("span", { className: t["content-item-text"], children: s.title })] }, s.key);
  }) }) })] }), e.jsxs("div", { className: t.block, children: [e.jsxs("div", { className: t.header, children: [e.jsx("div", { className: t.title, children: "选定列" }), e.jsxs("div", { className: t.reset, onClick: H, children: [e.jsx("div", { children: "重置  " }), e.jsx(hs, {})] })] }), e.jsx("div", { className: t.body, children: e.jsxs(ls, { modifiers: [ms, us], onDragStart: (s) => {
    const { active: o } = s;
    o && j(o == null ? void 0 : o.id);
  }, onDragCancel: () => j(null), onDragEnd: (s) => {
    j(null);
    const { over: o } = s;
    if (o) {
      const n = M(o.id);
      N !== n && P(N, n);
    }
  }, children: [e.jsx(as, { items: p == null ? void 0 : p.map((s) => s.key), strategy: cs, children: e.jsx("ul", { className: t.content, style: { background: "#fff" }, children: p == null ? void 0 : p.map((s) => e.jsx(rs, { item: s }, s.key)) }) }), e.jsx(ts, { adjustScale: !1, dropAnimation: fs, children: d ? e.jsxs("li", { className: F(t.moveItem), children: [e.jsx(ps, { size: 14, className: t.dragIcon }), e.jsx("span", { className: t["moveItem-text"], children: Q })] }) : null })] }) })] })] })] });
});
export {
  Os as default
};
